package lab10_solutions;

import java.util.Comparator;

/**
 *	Copyright (C) <2012> <Andreas Papadopoulos>
 * 
* This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or at your option) any later
 * version.
 * 
* This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


public interface ExtendedBinaryTree<E> {
	
    /** Returns the number of nodes in the tree. */
  public int size();

  /** Returns whether the tree is empty. */
  public boolean isEmpty();
  
  /**
   * Insert the element E into the tree
   */
  public boolean insert(E e);
  

  /**
   * Search for a specific element
   * @param e The element to look for
   * @return True if found
   */
  public boolean contains(E e); 
  
  /**
   * Search for a specific element
   * @param e The element to look for
   * @return The element if found or null
   */
  public E search(E e);
  
  
  /**
   * Remove a node from the tree
   * @param e The element to remove
   * @return true if removes it else false
   */
  public boolean remove(E e);
  
 
  
  /**
   * 
   * @return A String containing alphabetically all the elements in the tree
   */
  public String SortedRepresentation();
  
  
  
  /**
   * 
   * @return A String that represents the tree
   */
  public String TreeStructure();
  

}
